VERSION 5.00
Begin VB.Form frmRegister 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBRegServer"
   ClientHeight    =   4260
   ClientLeft      =   3690
   ClientTop       =   2040
   ClientWidth     =   7140
   Icon            =   "frmRegister.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4260
   ScaleWidth      =   7140
   Begin VB.FileListBox filMain 
      Height          =   3210
      Left            =   4050
      Pattern         =   "*.DLL;*.OCX"
      TabIndex        =   2
      Top             =   465
      Width           =   3015
   End
   Begin VB.DirListBox dirMain 
      Height          =   3240
      Left            =   75
      TabIndex        =   1
      Top             =   450
      Width           =   3915
   End
   Begin VB.DriveListBox drvMain 
      Height          =   315
      Left            =   75
      TabIndex        =   0
      Top             =   75
      Width           =   2865
   End
   Begin VB.Label lblMain 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   75
      TabIndex        =   4
      Top             =   3750
      Width           =   6990
   End
   Begin VB.Label Label1 
      Caption         =   "Select a DLL or OCX:"
      Height          =   240
      Left            =   4125
      TabIndex        =   3
      Top             =   225
      Width           =   2865
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOptions 
         Caption         =   "&Register"
         Index           =   0
         Shortcut        =   ^R
      End
      Begin VB.Menu mnuFileOptions 
         Caption         =   "&Unregister"
         Index           =   1
         Shortcut        =   ^U
      End
      Begin VB.Menu mnuFileOptions 
         Caption         =   "-"
         Index           =   2
      End
      Begin VB.Menu mnuFileOptions 
         Caption         =   "E&xit"
         Index           =   3
         Shortcut        =   ^X
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpInfo 
         Caption         =   "&System Info"
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "frmRegister"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private mblnRunning As Boolean

Private Const READ_CONTROL = &H20000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + _
                       KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + _
                       KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
                     
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const ERROR_SUCCESS = 0
Private Const REG_SZ = 1
Private Const REG_DWORD = 4

Private Const REGKEYSYSINFOLOC = "SOFTWARE\Microsoft\Shared Tools Location"
Private Const REGVALSYSINFOLOC = "MSINFO"
Private Const REGKEYSYSINFO = "SOFTWARE\Microsoft\Shared Tools\MSINFO"
Private Const REGVALSYSINFO = "PATH"

Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Private Declare Function GetSystemDirectory Lib "kernel32" _
    Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, _
    ByVal nSize As Long) As Long
Private Sub dirMain_Change()
    
    filMain.FileName = ""
    lblMain.Caption = ""
    filMain.Path = dirMain.Path

End Sub
Private Sub drvMain_Change()

    On Error GoTo ErrorHandler
    dirMain.Path = drvMain.Drive
    
    Exit Sub
    
ErrorHandler:
    Call MsgBox("The disk is not ready.", vbCritical, "Disk Access Error")
    drvMain.Drive = dirMain.Path
End Sub
Private Sub filMain_Click()
    
    lblMain.Caption = dirMain.Path & "\" & filMain.FileName
    If filMain.FileName = "" Then
        Call pDisableMenus
    Else
        Call pEnableMenus
    End If
    
End Sub
Private Sub Form_Load()
Dim strPath As String
    
    With Me
        .Left = (Screen.Width - .Width) / 2
        .Top = (Screen.Height - .Height) / 2
    End With
    
    Call pDisableMenus
    strPath = fSystemDirectory
    drvMain.Drive = Left(strPath, 1)
    dirMain.Path = strPath

End Sub
Private Sub Form_Unload(Cancel As Integer)

    Set frmRegister = Nothing

End Sub


Private Sub mnuFileOptions_Click(Index As Integer)
Dim blnReturn As Boolean
Dim strFile   As String

    Select Case Index
        Case 0, 1
            '
            ' Register/Unregister the file.
            '
            strFile = dirMain.Path & "\" & filMain.FileName
            If Right$(strFile, 1) = "\" Then
                Call MsgBox("No file selected!", vbCritical, "VBRegServer")
                Exit Sub
            End If
            
            If Not IsDLLActiveX(strFile, False) Then
                Call MsgBox("Not an ActiveX component!", vbCritical, "VBRegServer")
                Exit Sub
            End If
            
            If Index = 0 Then
                '
                ' Register the file.
                '
                blnReturn = fVBRegServer(strFile, True)
                
                If blnReturn Then
                    Call MsgBox("Registration of file '" & strFile & "' succeeded!", vbInformation, "VBRegServer")
                Else
                    Call MsgBox("Registration of file '" & strFile & "' failed!", vbCritical, "VBRegServer")
                End If
            Else
                '
                ' UnRegister the file.
                '
                blnReturn = fVBRegServer(strFile, False)
                
                If blnReturn Then
                    Call MsgBox("Unregistration of file '" & strFile & "' succeeded!", vbInformation, "VBRegServer")
                Else
                    Call MsgBox("Unregistration of file '" & strFile & "' failed!", vbCritical, "VBRegServer")
                End If
            End If
        
        Case 2
            '
            ' Separator
            '
        
        Case 3
            '
            ' Exit
            '
            Unload Me
    End Select
    
End Sub

Private Sub pEnableMenus()

    mnuFileOptions(0).Enabled = True
    mnuFileOptions(1).Enabled = True

End Sub
Private Sub pDisableMenus()

    mnuFileOptions(0).Enabled = False
    mnuFileOptions(1).Enabled = False
    
End Sub
Private Function fSystemDirectory() As String
Dim strWinPath As String
Dim strTemp    As String
    
    strWinPath = String(145, vbNullChar)
    strTemp = GetSystemDirectory(strWinPath, 145)
    fSystemDirectory = Left(strWinPath, InStr(strWinPath, vbNullChar) - 1)

End Function

Private Sub pStartSysInfo()
Dim rc As Long
Dim strSysInfoPath As String
    
    On Error GoTo ErrorHandler

    If fGetKeyValue(HKEY_LOCAL_MACHINE, REGKEYSYSINFO, REGVALSYSINFO, strSysInfoPath) Then
    ElseIf fGetKeyValue(HKEY_LOCAL_MACHINE, REGKEYSYSINFOLOC, REGVALSYSINFOLOC, strSysInfoPath) Then
        If (Dir(strSysInfoPath & "\MSINFO32.EXE") <> "") Then
            strSysInfoPath = strSysInfoPath & "\MSINFO32.EXE"
        Else
            GoTo ErrorHandler
        End If
    Else
        GoTo ErrorHandler
    End If
    
    Call Shell(strSysInfoPath, vbNormalFocus)
    Exit Sub
    
ErrorHandler:
    Call MsgBox("System Information Is Unavailable", vbExclamation, vbOKOnly)
End Sub

Private Function fGetKeyValue(ByVal lngKeyRoot As Long, ByVal strKeyName As String, _
        ByVal strSubKeyRef As String, ByRef strKeyVal As String) As Boolean

Dim i             As Long
Dim rc            As Long
Dim lngKey       As Long
Dim lngKeyValType As Long
Dim lngKeyValSize As Long
Dim strTmpVal     As String
    
    rc = RegOpenKeyEx(lngKeyRoot, strKeyName, 0, KEY_ALL_ACCESS, lngKey)
    If rc <> ERROR_SUCCESS Then GoTo ErrorHandler
    
    strTmpVal = String$(1024, 0)
    lngKeyValSize = 1024
    
    rc = RegQueryValueEx(lngKey, strSubKeyRef, 0, lngKeyValType, strTmpVal, lngKeyValSize)
    If rc <> ERROR_SUCCESS Then GoTo ErrorHandler
    
    If (Asc(Mid(strTmpVal, lngKeyValSize, 1)) = 0) Then
        strTmpVal = Left(strTmpVal, lngKeyValSize - 1)
    Else
        strTmpVal = Left(strTmpVal, lngKeyValSize)
    End If
    
    Select Case lngKeyValType
        Case REG_SZ
            strKeyVal = strTmpVal
            
        Case REG_DWORD
            For i = Len(strTmpVal) To 1 Step -1
                strKeyVal = strKeyVal + Hex(Asc(Mid(strTmpVal, i, 1)))
            Next
            strKeyVal = Format$("&h" + strKeyVal)
    End Select
    
    fGetKeyValue = True
    rc = RegCloseKey(lngKey)
    Exit Function
    
ErrorHandler:
    strKeyVal = ""
    fGetKeyValue = False
    rc = RegCloseKey(lngKey)
End Function


Private Sub mnuHelpInfo_Click()

    Call pStartSysInfo
    
End Sub


